Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -5807,216 +5839,210 @@
 !> Calculate saturation ratios of NH4 and HNO3 for aerosols
 !------------------------------------------------------------------------------!
- SUBROUTINE SVsat( ptemp, ppart, pachno3, pacnh4hso2, pachhso4, pchno3eq,      &
-                   pchno3, pcnh3, pkelhno3, pkelnh3, psathno3, psatnh3 )
+ SUBROUTINE nitrate_ammonium_saturation( ptemp, ppart, pachno3, pacnh4hso2, pachhso4, pchno3eq,    &
+                                         pchno3, pc_nh3, pkelhno3, pkelnh3, psathno3, psatnh3 )
 
     IMPLICIT NONE
-    
+
+    INTEGER(iwp) :: ib   !< running index for aerosol bins
+
+    REAL(wp) ::  k_ll_h2o   !< equilibrium constants of equilibrium reactions:
+                            !< H2O(aq) <--> H+ + OH- (mol/kg)
+    REAL(wp) ::  k_ll_nh3   !< NH3(aq) + H2O(aq) <--> NH4+ + OH- (mol/kg)
+    REAL(wp) ::  k_gl_nh3   !< NH3(g) <--> NH3(aq) (mol/kg/atm)
+    REAL(wp) ::  k_gl_hno3  !< HNO3(g) <--> H+ + NO3- (mol2/kg2/atm)
+    REAL(wp) ::  zmol_no3   !< molality of NO3- (mol/kg)
+    REAL(wp) ::  zmol_h     !< molality of H+ (mol/kg)
+    REAL(wp) ::  zmol_so4   !< molality of SO4(2-) (mol/kg)
+    REAL(wp) ::  zmol_cl    !< molality of Cl- (mol/kg)
+    REAL(wp) ::  zmol_nh4   !< molality of NH4+ (mol/kg)
+    REAL(wp) ::  zmol_na    !< molality of Na+ (mol/kg)
+    REAL(wp) ::  zhlp1      !< intermediate variable
+    REAL(wp) ::  zhlp2      !< intermediate variable
+    REAL(wp) ::  zhlp3      !< intermediate variable
+    REAL(wp) ::  zxi        !< particle mole concentration ratio: (NH3+SS)/H2SO4
+    REAL(wp) ::  zt0        !< reference temp
+
+    REAL(wp), PARAMETER ::  a1 = -22.52_wp     !<
+    REAL(wp), PARAMETER ::  a2 = -1.50_wp      !<
+    REAL(wp), PARAMETER ::  a3 = 13.79_wp      !<
+    REAL(wp), PARAMETER ::  a4 = 29.17_wp      !<
+    REAL(wp), PARAMETER ::  b1 = 26.92_wp      !<
+    REAL(wp), PARAMETER ::  b2 = 26.92_wp      !<
+    REAL(wp), PARAMETER ::  b3 = -5.39_wp      !<
+    REAL(wp), PARAMETER ::  b4 = 16.84_wp      !<
+    REAL(wp), PARAMETER ::  K01 = 1.01E-14_wp  !<
+    REAL(wp), PARAMETER ::  K02 = 1.81E-5_wp   !<
+    REAL(wp), PARAMETER ::  K03 = 57.64_wp     !<
+    REAL(wp), PARAMETER ::  K04 = 2.51E+6_wp   !<
+
     REAL(wp), INTENT(in) ::  ptemp  !< ambient temperature (K)
-    
-    TYPE(t_section), INTENT(inout) ::  ppart(nbins) !< Aerosol properties
-!-- Activity coefficients
-    REAL(wp), INTENT(in) ::  pachhso4(nbins)   !<
-    REAL(wp), INTENT(in) ::  pacnh4hso2(nbins) !<
-    REAL(wp), INTENT(in) ::  pachno3(nbins)    !<
-    REAL(wp), INTENT(in) ::  pchno3eq(nbins) !< Equilibrium surface concentration
-                                             !< of HNO3
-    REAL(wp), INTENT(in) ::  pchno3(nbins)   !< Current particle mole 
-                                             !< concentration of HNO3 (mol/m3)
-    REAL(wp), INTENT(in) ::  pcnh3(nbins)    !< Current particle mole 
-                                             !< concentration of NH3 (mol/m3)
-    REAL(wp), INTENT(in) ::  pkelhno3(nbins) !< Kelvin effect for HNO3
-    REAL(wp), INTENT(in) ::  pkelnh3(nbins)  !< Kelvin effect for NH3
-!-- Saturation ratios
-    REAL(wp), INTENT(out) ::  psathno3(nbins) !<
-    REAL(wp), INTENT(out) ::  psatnh3(nbins)  !< 
-    
-    INTEGER :: b   !< running index for aerosol bins
-!-- Constants for calculating equilibrium constants:    
-    REAL(wp), PARAMETER ::  a1 = -22.52_wp     !< 
-    REAL(wp), PARAMETER ::  a2 = -1.50_wp      !< 
-    REAL(wp), PARAMETER ::  a3 = 13.79_wp      !< 
-    REAL(wp), PARAMETER ::  a4 = 29.17_wp      !< 
-    REAL(wp), PARAMETER ::  b1 = 26.92_wp      !< 
-    REAL(wp), PARAMETER ::  b2 = 26.92_wp      !< 
-    REAL(wp), PARAMETER ::  b3 = -5.39_wp      !< 
-    REAL(wp), PARAMETER ::  b4 = 16.84_wp      !< 
-    REAL(wp), PARAMETER ::  K01 = 1.01E-14_wp  !< 
-    REAL(wp), PARAMETER ::  K02 = 1.81E-5_wp   !< 
-    REAL(wp), PARAMETER ::  K03 = 57.64_wp     !< 
-    REAL(wp), PARAMETER ::  K04 = 2.51E+6_wp   !< 
-!-- Equilibrium constants of equilibrium reactions
-    REAL(wp) ::  KllH2O    !< H2O(aq) <--> H+ + OH- (mol/kg)
-    REAL(wp) ::  KllNH3    !< NH3(aq) + H2O(aq) <--> NH4+ + OH- (mol/kg)
-    REAL(wp) ::  KglNH3    !< NH3(g) <--> NH3(aq) (mol/kg/atm)
-    REAL(wp) ::  KglHNO3   !< HNO3(g) <--> H+ + NO3- (mol2/kg2/atm)
-    REAL(wp) ::  zmolno3   !< molality of NO3- (mol/kg)
-    REAL(wp) ::  zmolhp    !< molality of H+ (mol/kg)
-    REAL(wp) ::  zmolso4   !< molality of SO4(2-) (mol/kg)
-    REAL(wp) ::  zmolcl    !< molality of Cl (mol/kg)
-    REAL(wp) ::  zmolnh4   !< Molality of NH4 (mol/kg)
-    REAL(wp) ::  zmolna    !< Molality of Na (mol/kg)
-    REAL(wp) ::  zhlp1     !<
-    REAL(wp) ::  zhlp2     !<
-    REAL(wp) ::  zhlp3     !<
-    REAL(wp) ::  zxi       !<
-    REAL(wp) ::  zt0       !< Reference temp
-    
-    zhlp1   = 0.0_wp
-    zhlp2   = 0.0_wp 
-    zhlp3   = 0.0_wp
-    zmolcl  = 0.0_wp
-    zmolhp  = 0.0_wp
-    zmolna  = 0.0_wp
-    zmolnh4 = 0.0_wp
-    zmolno3 = 0.0_wp
-    zmolso4 = 0.0_wp
-    zt0     = 298.15_wp 
-    zxi     = 0.0_wp
-!
-!-- Calculates equlibrium rate constants based on Table B.7 in Jacobson (2005) 
-!-- K^ll_H20, K^ll_NH3, K^gl_NH3, K^gl_HNO3 
+
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pachhso4    !< activity coeff. of HHSO4
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pacnh4hso2  !< activity coeff. of NH4HSO2
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pachno3     !< activity coeff. of HNO3
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pchno3eq    !< eq. surface concentration: HNO3
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pchno3      !< current particle mole
+                                                                   !< concentration of HNO3 (mol/m3)
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pc_nh3      !< of NH3 (mol/m3)
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pkelhno3    !< Kelvin effect for HNO3
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pkelnh3     !< Kelvin effect for NH3
+
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(out) ::  psathno3 !< saturation ratio of HNO3
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(out) ::  psatnh3  !< saturation ratio of NH3
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  ppart  !< Aerosol properties
+
+    zmol_cl  = 0.0_wp
+    zmol_h   = 0.0_wp
+    zmol_na  = 0.0_wp
+    zmol_nh4 = 0.0_wp
+    zmol_no3 = 0.0_wp
+    zmol_so4 = 0.0_wp
+    zt0      = 298.15_wp
+    zxi      = 0.0_wp
+!
+!-- Calculates equlibrium rate constants based on Table B.7 in Jacobson (2005):
+!-- K^ll_H20, K^ll_NH3, K^gl_NH3, K^gl_HNO3
     zhlp1 = zt0 / ptemp
     zhlp2 = zhlp1 - 1.0_wp
     zhlp3 = 1.0_wp + LOG( zhlp1 ) - zhlp1
 
-    KllH2O = K01 * EXP( a1 * zhlp2 + b1 * zhlp3 )
-    KllNH3 = K02 * EXP( a2 * zhlp2 + b2 * zhlp3 )
-    KglNH3 = K03 * EXP( a3 * zhlp2 + b3 * zhlp3 )
-    KglHNO3 = K04 * EXP( a4 * zhlp2 + b4 * zhlp3 )
-
-    DO  b = 1, nbins
-
-       IF ( ppart(b)%numc > nclim  .AND.  ppart(b)%volc(8) > 1.0E-30_wp  )  THEN
-!
-!--       Molality of H+ and NO3- 
-          zhlp1 = pcnh3(b) * amnh3 + ppart(b)%volc(1) * arhoh2so4 +            &
-                  ppart(b)%volc(2) * arhooc + ppart(b)%volc(5) * arhoss +      &
-                  ppart(b)%volc(8) * arhoh2o
-          zmolno3 = pchno3(b) / zhlp1  !< mol/kg
-!
-!--       Particle mole concentration ratio: (NH3+SS)/H2SO4       
-          zxi = ( pcnh3(b) + ppart(b)%volc(5) * arhoss / amss ) /              &
-                ( ppart(b)%volc(1) * arhoh2so4 / amh2so4 )
-                
+    k_ll_h2o  = K01 * EXP( a1 * zhlp2 + b1 * zhlp3 )
+    k_ll_nh3  = K02 * EXP( a2 * zhlp2 + b2 * zhlp3 )
+    k_gl_nh3  = K03 * EXP( a3 * zhlp2 + b3 * zhlp3 )
+    k_gl_hno3 = K04 * EXP( a4 * zhlp2 + b4 * zhlp3 )
+
+    DO  ib = 1, nbins_aerosol
+
+       IF ( ppart(ib)%numc > nclim  .AND.  ppart(ib)%volc(8) > 1.0E-30_wp  )  THEN
+!
+!--       Molality of H+ and NO3-
+          zhlp1 = pc_nh3(ib) * amnh3 + ppart(ib)%volc(1) * arhoh2so4 + ppart(ib)%volc(2) * arhooc  &
+                  + ppart(ib)%volc(5) * arhoss + ppart(ib)%volc(8) * arhoh2o
+          zmol_no3 = pchno3(ib) / zhlp1  !< mol/kg
+!
+!--       Particle mole concentration ratio: (NH3+SS)/H2SO4
+          zxi = ( pc_nh3(ib) + ppart(ib)%volc(5) * arhoss / amss ) / ( ppart(ib)%volc(1) *         &
+                  arhoh2so4 / amh2so4 )
+
           IF ( zxi <= 2.0_wp )  THEN
 !
 !--          Molality of SO4(2-)
-             zhlp1 = pcnh3(b) * amnh3 + pchno3(b) * amhno3 +                   &
-                     ppart(b)%volc(2) * arhooc + ppart(b)%volc(5) * arhoss +   &
-                     ppart(b)%volc(8) * arhoh2o
-             zmolso4 = ( ppart(b)%volc(1) * arhoh2so4 / amh2so4 ) / zhlp1
+             zhlp1 = pc_nh3(ib) * amnh3 + pchno3(ib) * amhno3 + ppart(ib)%volc(2) * arhooc +       &
+                     ppart(ib)%volc(5) * arhoss + ppart(ib)%volc(8) * arhoh2o
+             zmol_so4 = ( ppart(ib)%volc(1) * arhoh2so4 / amh2so4 ) / zhlp1
 !
 !--          Molality of Cl-
-             zhlp1 = pcnh3(b) * amnh3 + pchno3(b) * amhno3 +                   &
-                     ppart(b)%volc(2) * arhooc + ppart(b)%volc(1) * arhoh2so4  &
-                     + ppart(b)%volc(8) * arhoh2o
-             zmolcl = ( ppart(b)%volc(5) * arhoss / amss ) / zhlp1
+             zhlp1 = pc_nh3(ib) * amnh3 + pchno3(ib) * amhno3 + ppart(ib)%volc(2) * arhooc +       &
+                     ppart(ib)%volc(1) * arhoh2so4 + ppart(ib)%volc(8) * arhoh2o
+             zmol_cl = ( ppart(ib)%volc(5) * arhoss / amss ) / zhlp1
 !
 !--          Molality of NH4+
-             zhlp1 =  pchno3(b) * amhno3 + ppart(b)%volc(1) * arhoh2so4 +      &
-                      ppart(b)%volc(2) * arhooc + ppart(b)%volc(5) * arhoss +  &
-                      ppart(b)%volc(8) * arhoh2o
-             zmolnh4 = pcnh3(b) / zhlp1
-!             
+             zhlp1 =  pchno3(ib) * amhno3 + ppart(ib)%volc(1) * arhoh2so4 + ppart(ib)%volc(2) *    &
+                      arhooc + ppart(ib)%volc(5) * arhoss + ppart(ib)%volc(8) * arhoh2o
+             zmol_nh4 = pc_nh3(ib) / zhlp1
+!
 !--          Molality of Na+
-             zmolna = zmolcl
+             zmol_na = zmol_cl
 !
 !--          Molality of H+
-             zmolhp = 2.0_wp * zmolso4 + zmolno3 + zmolcl - ( zmolnh4 + zmolna )
+             zmol_h = 2.0_wp * zmol_so4 + zmol_no3 + zmol_cl - ( zmol_nh4 + zmol_na )
 
           ELSE
 
-             zhlp2 = pkelhno3(b) * zmolno3 * pachno3(b) ** 2.0_wp
-!
-!--          Mona debugging
+             zhlp2 = pkelhno3(ib) * zmol_no3 * pachno3(ib)**2
+
              IF ( zhlp2 > 1.0E-30_wp )  THEN
-                zmolhp = KglHNO3 * pchno3eq(b) / zhlp2 ! Eq. 17.38
+                zmol_h = k_gl_hno3 * pchno3eq(ib) / zhlp2 ! Eq. 17.38
              ELSE
-                zmolhp = 0.0_wp
+                zmol_h = 0.0_wp
              ENDIF
 
           ENDIF
 
-          zhlp1 = ppart(b)%volc(8) * arhoh2o * argas * ptemp * KglHNO3
+          zhlp1 = ppart(ib)%volc(8) * arhoh2o * argas * ptemp * k_gl_hno3
 !
 !--       Saturation ratio for NH3 and for HNO3
-          IF ( zmolhp > 0.0_wp )  THEN
-             zhlp2 = pkelnh3(b) / ( zhlp1 * zmolhp )
-             zhlp3 = KllH2O / ( KllNH3 + KglNH3 )
-             psatnh3(b) = zhlp2 * ( ( pacnh4hso2(b) / pachhso4(b) ) **2.0_wp ) &
-                          * zhlp3
-             psathno3(b) = ( pkelhno3(b) * zmolhp * pachno3(b)**2.0_wp ) / zhlp1
+          IF ( zmol_h > 0.0_wp )  THEN
+             zhlp2 = pkelnh3(ib) / ( zhlp1 * zmol_h )
+             zhlp3 = k_ll_h2o / ( k_ll_nh3 + k_gl_nh3 )
+             psatnh3(ib) = zhlp2 * ( ( pacnh4hso2(ib) / pachhso4(ib) )**2 ) * zhlp3
+             psathno3(ib) = ( pkelhno3(ib) * zmol_h * pachno3(ib)**2 ) / zhlp1
           ELSE
-             psatnh3(b) = 1.0_wp
-             psathno3(b) = 1.0_wp
+             psatnh3(ib) = 1.0_wp
+             psathno3(ib) = 1.0_wp
           ENDIF
        ELSE
-          psatnh3(b) = 1.0_wp
-          psathno3(b) = 1.0_wp
+          psatnh3(ib) = 1.0_wp
+          psathno3(ib) = 1.0_wp
        ENDIF
 
     ENDDO
 
-  END SUBROUTINE SVsat
- 
+  END SUBROUTINE nitrate_ammonium_saturation
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Prototype module for calculating the water content of a mixed inorganic/
-!> organic particle + equilibrium water vapour pressure above the solution 
-!> (HNO3, HCL, NH3 and representative organic compounds. Efficient calculation 
-!> of the partitioning of species between gas and aerosol. Based in a chamber 
-!> study. 
-!
-!> Written by Dave Topping. Pure organic component properties predicted by Mark 
-!> Barley based on VOCs predicted in MCM simulations performed by Mike Jenkin. 
-!> Delivered by Gordon McFiggans as Deliverable D22 from WP1.4 in the EU FP6 
+!> organic particle + equilibrium water vapour pressure above the solution
+!> (HNO3, HCL, NH3 and representative organic compounds. Efficient calculation
+!> of the partitioning of species between gas and aerosol. Based in a chamber
+!> study.
+!
+!> Written by Dave Topping. Pure organic component properties predicted by Mark
+!> Barley based on VOCs predicted in MCM simulations performed by Mike Jenkin.
+!> Delivered by Gordon McFiggans as Deliverable D22 from WP1.4 in the EU FP6
 !> EUCAARI Integrated Project.
 !
-!> Queries concerning the use of this code through Gordon McFiggans, 
+!> REFERENCES
+!> Clegg et al. (1998) A Thermodynamic Model of the System H+-NH4+-Na+-SO42- -NO3--Cl--H2O at
+!>    298.15 K, J. Phys. Chem., 102A, 2155-2171.
+!> Clegg et al. (2001) Thermodynamic modelling of aqueous aerosols containing electrolytes and
+!>    dissolved organic compounds. Journal of Aerosol Science 2001;32(6):713-738.
+!> Topping et al. (2005a) A curved multi-component aerosol hygroscopicity model framework: Part 1 -
+!>    Inorganic compounds. Atmospheric Chemistry and Physics 2005;5:1205-1222.
+!> Topping et al. (2005b) A curved multi-component aerosol hygroscopicity model framework: Part 2 -
+!>    Including organic compounds. Atmospheric Chemistry and Physics 2005;5:1223-1242.
+!> Wagman et al. (1982). The NBS tables of chemical thermodynamic properties: selected values for
+!>    inorganic and Câ and Câ organic substances in SI units (book)
+!> Zaveri et al. (2005). A new method for multicomponent activity coefficients of electrolytes in
+!>    aqueous atmospheric aerosols, JGR, 110, D02201, 2005.
+!
+!> Queries concerning the use of this code through Gordon McFiggans,
 !> g.mcfiggans@manchester.ac.uk,
-!> Ownership: D. Topping, Centre for Atmospheric Sciences, University of 
+!> Ownership: D. Topping, Centre for Atmospheric Sciences, University of
 !> Manchester, 2007
 !
 !> Rewritten to PALM by Mona Kurppa, UHel, 2017
 !------------------------------------------------------------------------------!
- SUBROUTINE inorganic_pdfite( RH, temp, ions, water_total, Press_HNO3,         &
-                               Press_HCL, Press_NH3, gamma_out, mols_out )
-    
+ SUBROUTINE inorganic_pdfite( rh, temp, ions, water_total, press_hno3, press_hcl, press_nh3,       &
+                              gamma_out, mols_out )
+
     IMPLICIT NONE
-    
-    REAL(wp), DIMENSION(:) ::  gamma_out !< Activity coefficient for calculating 
-                                         !< the non-ideal dissociation constants
-                                         !< 1: HNO3, 2: HCL, 3: NH4+/H+ (NH3)
-                                         !< 4: HHSO4**2/H2SO4, 
-                                         !< 5: H2SO4**3/HHSO4**2
-                                         !< 6: NH4HSO2, 7: HHSO4
-    REAL(wp), DIMENSION(:) ::  ions      !< ion molarities (mol/m3)
-                                         !< 1: H+, 2: NH4+, 3: Na+, 4: SO4(2-),
-                                         !< 5: HSO4-, 6: NO3-, 7: Cl-
-    REAL(wp), DIMENSION(7) ::  ions_mol  !< ion molalities (mol/kg)
-                                         !< 1: H+, 2: NH4+, 3: Na+, 4: SO4(2-), 
-                                         !< 5: HSO4-, 6: NO3-, 7: Cl-
-    REAL(wp), DIMENSION(:) ::  mols_out  !< ion molality output (mol/kg)
-                                         !< 1: H+, 2: NH4+, 3: Na+, 4: SO4(2-),
-                                         !< 5: HSO4-, 6: NO3-, 7: Cl-
+
+    INTEGER(iwp) ::  binary_case
+    INTEGER(iwp) ::  full_complexity
+
+    REAL(wp) ::  a                         !< auxiliary variable
     REAL(wp) ::  act_product               !< ionic activity coef. product:
-                                           !< = (gamma_h2so4**3d0) / 
-                                           !<   (gamma_hhso4**2d0)       
-    REAL(wp) ::  ammonium_chloride         !< 
-    REAL(wp) ::  ammonium_chloride_eq_frac !<                          
-    REAL(wp) ::  ammonium_nitrate          !< 
-    REAL(wp) ::  ammonium_nitrate_eq_frac  !<       
-    REAL(wp) ::  ammonium_sulphate         !<  
+                                           !< = (gamma_h2so4**3d0) / gamma_hhso4**2d0)
+    REAL(wp) ::  ammonium_chloride         !<
+    REAL(wp) ::  ammonium_chloride_eq_frac !<
+    REAL(wp) ::  ammonium_nitrate          !<
+    REAL(wp) ::  ammonium_nitrate_eq_frac  !<
+    REAL(wp) ::  ammonium_sulphate         !<
     REAL(wp) ::  ammonium_sulphate_eq_frac !<
-    REAL(wp) ::  binary_h2so4              !< binary H2SO4 activity coeff.       
+    REAL(wp) ::  b                         !< auxiliary variable
+    REAL(wp) ::  binary_h2so4              !< binary H2SO4 activity coeff.
     REAL(wp) ::  binary_hcl                !< binary HCL activity coeff.
-    REAL(wp) ::  binary_hhso4              !< binary HHSO4 activity coeff.     
+    REAL(wp) ::  binary_hhso4              !< binary HHSO4 activity coeff.
     REAL(wp) ::  binary_hno3               !< binary HNO3 activity coeff.
-    REAL(wp) ::  binary_nh4hso4            !< binary NH4HSO4 activity coeff.    
+    REAL(wp) ::  binary_nh4hso4            !< binary NH4HSO4 activity coeff.
+    REAL(wp) ::  c                         !< auxiliary variable
     REAL(wp) ::  charge_sum                !< sum of ionic charges
-    REAL(wp) ::  gamma_h2so4               !< activity coefficient       
+    REAL(wp) ::  gamma_h2so4               !< activity coefficient
     REAL(wp) ::  gamma_hcl                 !< activity coefficient
-    REAL(wp) ::  gamma_hhso4               !< activity coeffient       
+    REAL(wp) ::  gamma_hhso4               !< activity coeffient
     REAL(wp) ::  gamma_hno3                !< activity coefficient
     REAL(wp) ::  gamma_nh3                 !< activity coefficient
